{ Siro 30.03.2021 }
{ Testprogramm für die Umsetzung meiner Idee zum Speichern von Daten in der eigenen .exe Datei }

unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

Type TMyIni = record
  ident1 :Int64;         // Ein erster  8 Byte Identifizierungswert
  ident2 :Int64;         // ein zweiter 8 Byte Identifizierungswert
  FirstUse:Boolean;      // True wenn das Programm das aller erste Mal gestartet wurde
  ProgramUsed:Integer;   // Anzahl der Programmstarts
                         // irgendwelche Parameter
  name:Array[0..7] of Char;
  param1:Integer;
  param2:Integer;
end;

Type pMyIni=^TMyIni;   // Zeiger auf einen TMyIni Record

// Beliebig festgelegte Identifizierungswerte
// Es wird in der Datei nach diesen beiden Werten gesucht.
// Diese müssen sich direkt hintereinander befinden
// Das war nötig, da der Compiler Abfragen mit diesen Werten tätigte
// und nur eine Abfrage des Identifizierungscodes zu Fehlern führte,
// da dieser Wert mehrfach auftauchte.
// Das diese beiden Werte nun direkt hintereinander auftauchen, dürfe fast unmöglich sein

const MyIdentCode1 = $8CEF55376155;
const MyIdentCode2 = $55613755EF8C;

const MyIni : TMyIni =
( ident1:MyIdentCode1;
  ident2:MyIdentCode2;

  //.. hier kommen die ganzen Parameter rein die gespeichert werden sollen
  // Die Grundinitialisierung ist für den "ersten" Start des Programms
  FirstUse    : TRUE;
  ProgramUsed : 1;
  name        :'Siro';
  param1      : $34;
  param2      : $127;
  //...usw. beliebig erweiterbar
);

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  Caption:='Starts:'+IntToStr(MyIni.ProgramUsed);    // Anzahl der Programmstarts ausgeben
  if MyIni.FirstUse then Label1.caption:='Erstbenutzung Ja'
                    else Label1.caption:='Erstbenutzung Nein';
  Label2.caption:=MyIni.name;
end;

procedure TForm1.Button1Click(Sender: TObject);
var f:file; size,i:Integer; buffer,p:pByte;
begin
  // testweise die Parameter ändern und wieder in der Datei speichern
  MyIni.FirstUse   :=FALSE;
  MyIni.ProgramUsed:=MyIni.ProgramUsed + 1;
  MyIni.name:='Merkel';    // bischen Spass muss sein....

  // Die Änderung in die eigene .exe Datei schreiben

  // Erstmal die ganze Datei laden in den Speicher
  AssignFile(f,'Project1.exe');
  Filemode := fmOpenRead or fmShareDenyNone;  // sonst geht die nächste Zeile schief
  Reset(F,1);
  size:=FileSize(f);
  buffer:=GetMem(size);          // Speicher für die gesamte Datei reservieren
  BlockRead(f,buffer^,size);     // gesamte .exe Dateie einlesen
  CloseFile(f);                  // Datei wieder schliessen

  // jetzt wird der Puffer "Byteweise" durchsucht bis die Identifizierung gefunden wird
  p:=buffer;                                     // Startadresse ist der buffer
  for i:=0 to size-1 do begin
    if (pMyIni(p)^.ident1 = MyIdentCode1) and    // das reicht nicht aus, wir benötigen einen zusätzlichen Test
       (pMyIni(p)^.ident2 = MyIdentCode2) then   // der 2te Wert muss auch stimmen
        break                                    // bei erfolgreichem Fund die for i Schleife sofort beenden
    else inc(p);                                 // ansonsten ein Byte vorrücken
  end;

  Move(MyIni,p^,SizeOf(MyIni));                  // Die neuen Parameter setzen im Speicher

  // Die Datei aus dem Speicher zurück auf Festplallte schreiben
  Filemode := fmOpenWrite or fmShareDenyNone;    // braucht man hier evtl. noch zusätzliche Flags ?????
  AssignFile(f,'Project2.exe');                  // !!!!!!!! <=====  Project1.exe geht nicht =========  !!!!!!!!!
  ReWrite(f,1);
  BlockWrite(f,buffer^,size);
  CloseFile(f);

  FreeMem(buffer,size);        // den Speicher wieder freigeben
end;

end.

